/**********************************************************************
 *                                                                    *
 *                            Monk3y 7                                *
 *                                                                    *
 *                 A simple "sette e mezzo" card game!                *
 *               gcc monkey7.c -o monkey7 for compile.                *
 *                                                                    *
 *       This game is released as open source under GPL license       *
 *        http://creativecommons.org/licenses/GPL/2.0/deed.it         *
 *             http://www.gnu.org/licenses/gpl-2.0.txt                *
 *                                                                    *
 *   This game is provided without warranty, use it at your own risk! *
 *                                                                    *
 *                     pix3lworkshop.altervista.org                   *
 *                                                                    *
 *********************************************************************/
#include <stdio.h>
#include <time.h>

void logo(void);
void mischia(void);
float distribuisci(char **, char **, char *);
void gioco(char **, char **);
int ia(float, float);
float com(char **, char **, float, char *, int, float *, float, float);
float ia_bet(float, float, float);
void logo_win(void);
int money_check(float, float, float);


int mazzo[4][10]={0};
int pos=1;

main()
{
      char *tipi[4]={"Bastoni", "Coppe", "Denari", "Spade"};
      char *numeri[10]={"Asso", "Due", "Tre", "Quattro", "Cinque", "Sei",
                        "Sette", "Donna", "Fante", "Re"};

      srand(time(0));
      logo();
      gioco(tipi, numeri);
      getchar();
}

void logo()
{
printf(" __  __   ___   _   _ __   __ ___  __    __  _______ \n"
       "|  \\/  | /   \\ | \\ | |  | / /|__ \\ \\ \\  / / |_____  /\n"
       "|      ||  /\\ ||  \\| |  |/ /    | | \\ \\/ /       / / \n"
       "| |\\/| ||  \\/ || |\\  |     \\   |  |  \\  /       / /  \n"
       "|_|  |_| \\___/ |_| \\_|__|\\__\\ __| |__/ /       / /   \n"
       "                             |___/____/       /_/    \n");

  printf("\t\t");
  printf("Premi un invio per continuare");
 printf("\n\n");
}

void gioco(char **semi, char **num)
{
     float soldi=10.00, soldi_pc=10.00;
     char check, check1;
     //check1=altra_mano
     char carta[20], coperta[20];
     float p=0.0, bet=0.0, ris=0.0;
     float game=0.0;
     float bet_pc=0.0;
     float first_time=0.0;
     
     printf("\nHai a disposizione per giocare: %0.2f Euro\n"
            "Il computer ha a disposizione: %0.2f Euro\n", soldi, soldi_pc);
     getchar();
     mischia();
     
     //check1='s' - Ciclo generale del programma
     do
     {
      first_time=0.0; //Si tiene conto del punteggio partendo da zero
      printf("\n\n------------------------------\nE' il tuo turno...\n\n");
      getchar();
      p=distribuisci(semi, num, carta);
      pos++; //incrementiamo pos di 1 - A 40 mischiamo
      first_time=p; //Si aggiorna il punteggio
      printf("%s\n", carta);
     
      //Finche' la puntata non e' corretta:
      do
      {
       printf("Quanti soldi vuoi puntare? ");
       scanf("%f", &bet);
       getchar();
      } while(money_check(bet, soldi, soldi_pc)==0);

      //Finche si ha check=='s':
      do
      {
       carta:
       printf("\nCarta? (s/n) ");
       
       //Si richiede una carta:
       do
       {
        check=getchar();
        printf("\n");
       } while(check!='s' && check!='n'); 
      
       //Se la risposta e' SI - Partita del giocatore
       if(check=='s')
       {
        ris=distribuisci(semi, num, carta);
        pos++;
        printf("%s\n", carta);
        p+=ris;
        if(p>7.5000)
         {
          printf("\nMi spiace hai sballato!!");
          soldi-=bet;
          soldi_pc+=bet;
          check='n';
         }
       else
        if(p==7.5000)
         {
          printf("\nSette e Mezzo!!");
          check='n';
         }
       }
      } while(check=='s');
      //Partita del giocatore - fine
     
       game=com(semi, num, p-first_time, carta, 0, &bet_pc, soldi_pc, soldi);
        if(game>7.5)
         {
          printf("\nIl Computer ha sballato, hai vinto %0.2f euro", bet);
          soldi+=bet;
          soldi_pc-=bet;
         }
        else
         {
          if(game==7.5)
          printf("\nIl Computer ha fatto Sette e Mezzo!!");
          if(game>=p)
           {
            printf("\nMi spiace hai perso %0.2f euro", bet);
            soldi-=bet;
            soldi_pc+=bet;
           }
          else
           {
            printf("\nComplimenti hai vinto %0.2f euro", bet);
            soldi+=bet;
            soldi_pc-=bet;
           }
         }

     //Controlliamo i soldi in possesso dei giocatori      
     if(soldi<=0)
      {
       printf("\n\nMi dispiace hai perso tutti i soldi");
       check1='n';
      }
     else
      {
       if(soldi_pc<=0)
        {
         printf("\n\nComplimenti hai sbancato il Computer");
         logo_win();
         check1='n';
        }
       else
        {
         printf("\nHai %0.2f euro - Il pc ha %0.2f euro\n\n", soldi, soldi_pc);
         getchar();
        }
         //Si richiede se giocare un'altra partita
         do
          {
           printf("\nVuoi fare un'altra mano? (s/n) ");
           check1=getchar();
           printf("\n");
          } while(check1!='s' && check1!='n');
      }
     } while(check1=='s');
}
                                      
void mischia()
{
     int i, j;
     int riga, colonna;
     //azzero la matrice
     for(i=0; i<4; i++)
       for(j=0; j<10; j++)
         mazzo[i][j]=0;
     srand(time(0));     
     for(i=1; i<=40; i++)
     {
              do
              {
                     riga=rand()%4;
                     colonna=rand()%10;
              } while(mazzo[riga][colonna]!=0);
              
              mazzo[riga][colonna]=i;
     }
     pos=1;
     printf("\nIl mazzo di carte e' stato mischiato...\n");
     getchar();
}

float distribuisci(char **semi, char **num, char *carta)
{
      float val[10]={1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 0.5, 0.5, 0.5};
      float x=0.0;
      int j=0, k=0;
      
      if(pos==40)
        mischia();
        
      for(j=0; j<4; j++)
        for(k=0; k<10; k++)
          if(mazzo[j][k]==pos)
          {
          	//Tipo + numero
            sprintf(carta ,"%s di %s", num[k], semi[j]);
            //Controlliamo il valore della carta
            x=val[k];
          }
      return x;
}

/* Questa funzione restituisce 1 se il   */
/* computer vuole una carta, 0 altrimenti*/
int ia(float val, float score)
{
    int gen=0;
    
    if(score!=0.0)
    {
      if(score>0.0)
      {
        if(score>=val)
          return 1;
      }
    }
    gen=rand() % 100;
    if(val==0.5)
      if(gen<=95)
        return 1;
    if(val==1.0)
      if(gen<=93)
        return 1;
    if(val==1.5)
      if(gen<=92)
        return 1;
    if(val==2.0)
      if(gen<=91)
        return 1;
    if(val==2.5)
      if(gen<=90)
        return 1;
    if(val==3.0)
      if(gen<=90)
        return 1;
    if(val==3.5)
      if(gen<=85)
        return 1;
    if(val==4.0)
      if(gen<=80)
        return 1;
    if(val==4.5)
      if(gen<=75)
        return 1;
    if(val==5.0)
      if(gen<=65)
        return 1;
    if(val==5.5)
      if(gen<=55)
        return 1;
    if(val==6.0)
      if(gen<=20)
        return 1;
    if(val==6.5)
      if(gen<=15)
        return 1;
    if(val==7.0)
      if(gen<=5)
        return 1;
    return 0;
}  

float com(char **semi, char **num, float score, char *carta, int turno, float *bet, float soldi_pc, float soldi)
{
    float parz=0.0, ia_score=0.0;
    int card=1;
    char carta1[20];
    
    printf("\nE' il turno del computer...");
    getchar();
    ia_score=distribuisci(semi, num, carta);
    pos++;
    if(turno==0)
    {
      printf("\n%s\n", carta);
    }
    else
    {
      printf("\nIl Computer osserva la carta appena ricevuta...");
      getchar();
      *bet=ia_bet(ia_score, soldi_pc, soldi);
      printf("\nIl Computer ha scommesso %0.2f Euro\n", *bet);
      getchar();
    }
    card=ia(ia_score, score);
    while(card==1)
    {
      printf("\nIl computer ha chiesto una carta...");
      getchar();
      parz=distribuisci(semi, num, carta1);
      pos++;
      printf("\n%s\n", carta1);
      ia_score+=parz;
      card=ia(ia_score, score);
    }
    return ia_score;
}

float ia_bet(float carta, float soldi_pc, float soldi)
{
  int x=0;
  float bet_pc=0.0;
  
  x=rand() % 100;
  if(carta==0.5)
    if(x<50)
      bet_pc=0.50;
    else
      if(x<65)
        bet_pc=1.00;
      else
        bet_pc=0.80;
  if(carta==1.0 || carta==2.0)
    if(x<75)
      bet_pc=0.50;
    else
      bet_pc=0.70;
  if(carta==3.0 || carta==4.0)
    if(x<70)
      bet_pc=0.80;
    else
      bet_pc=1.00;
  if(carta==5.0)
    if(x<50)
      bet_pc=0.30;
    else
      bet_pc=0.80;
  if(carta==6.0)
    if(x<85)
      bet_pc=1.50;
    else
      bet_pc=2.00;
  if(carta==7.0)
    if(x<10)
      bet_pc=soldi_pc-1.00;
    else
      if(x<50)
        bet_pc=soldi_pc/2;
      else
        bet_pc=soldi_pc/4;
  if(bet_pc>soldi_pc)
    bet_pc=soldi_pc;
  if(bet_pc>soldi)
    bet_pc=soldi;
  return bet_pc;
}

void logo_win()
{
  int i=0;
  
  getchar();
  printf("\n"
  "_/    _/            _/      _/      _/  _/              _/               \n"
  "_/    _/    _/_/_/          _/      _/      _/_/_/    _/_/_/_/    _/_/    \n"
  "_/_/_/_/  _/    _/  _/      _/      _/  _/  _/    _/    _/      _/    _/   \n"
  "_/    _/  _/    _/  _/        _/  _/    _/  _/    _/    _/      _/    _/    \n"
  "_/    _/    _/_/_/  _/          _/      _/  _/    _/      _/_/    _/_/       \n");

}


/*questa funzione ritorna 0 se non hai scommesso bene, 1 viceversa*/
int money_check(float bet, float soldi, float soldi_pc)
{
  if(bet<0.0)
  {
    printf("\nPuntanta non consentita!\n");
    return 0;
  }
  if(bet==0.0)
  {
    printf("\nDevi puntare qualcosa per giocare\n");
    return 0;
  }
  if(bet>soldi)
  {
    printf("\nNon hai soldi sufficienti per coprire questa puntata.\n");
    return 0;
  }
  if(bet>soldi_pc)
  {
    printf("\nIl Computer non puo' coprire questa puntata.\n");
    return 0;
  }
  return 1;
}
